// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.jboss

import javax.xml.parsers.DocumentBuilderFactory
import javax.xml.parsers.DocumentBuilder
import javax.xml.transform.dom.DOMSource
import javax.xml.transform.stream.StreamResult
import javax.xml.transform.TransformerFactory
import javax.xml.transform.Transformer
import javax.xml.transform.OutputKeys
import javax.xml.xpath.XPathFactory
import javax.xml.xpath.XPathConstants
import org.w3c.dom.Document
import org.w3c.dom.Node
//import org.apache.commons.io.FileUtils

class Mailsession47 extends Resource {
    static Map versionNameSpaces = [
                        '7.0' : "urn:jboss:domain:mail:1.0" ,
                        '7.1' : "urn:jboss:domain:mail:1.0"
                   ]            
    String resourceType = "mailsession"
	
	
    String name;
    String jndiname;
    String servername;
    String mailhost;
    String user;
    String password;
	String versionName;
    
    Mailsession47() {
	 	
	}
	Mailsession47(mailsessionname,j,s,h){
		name = mailsessionname
		jndiname = j
		servername = s
		mailhost = h
		user=null
		password=null
	}
    Mailsession47(mailsessionname,j,s,h,u,p ){
        name = mailsessionname
        jndiname = j
        servername = s
        mailhost = h
        user = u
        password = p
    }
    /*
    mailsession.ms1.name=sas-mail-service
    mailsession.ms1.jndiname=sas/mail/Session
    mailsession.ms1.mailhost=mailhost.fyi.sas.com
    mailsession.ms1.user=user@foobar.com
    mailsession.ms1.password=xxxxxx
    mailsession.ms1.servername=SASServer1
    */
    int configure(String instance, Properties scriptProperties){
        try {
       // makeExtentionModule("")
		Logger.log('DEBUG', "mailsession - Configuring ${name}")

        name = scriptProperties.get("mailsession."+instance+".name")
		Logger.log('DEBUG', "mailsession - Configuring ${name}")
        jndiname = scriptProperties.get("mailsession."+instance+".jndiname")  
		Logger.log('DEBUG', "mailsession - Configuring ${jndiname}")
        mailhost = scriptProperties.get("mailsession."+instance+".mailhost")
		Logger.log('DEBUG', "mailsession - Configuring ${mailhost}")
        user = scriptProperties.get("mailsession."+instance+".user")
		Logger.log('DEBUG', "mailsession - Configuring ${user}")
        password = scriptProperties.get("mailsession."+instance+".password")
		Logger.log('DEBUG', "mailsession - Configuring ${password}")
        servername = scriptProperties.get("mailsession."+instance+".servername")
		Logger.log('DEBUG', "mailsession - Configuring ${servername}")
        def jbossInstallDir = scriptProperties.'config.jboss.install.dir'
		versionName = new JBoss7Version(jbossInstallDir).getJBoss7Version()
		Logger.log('DEBUG', "mailsession - Configuring ${versionName}")
		versionName = versionName.substring(0,3)

        Logger.log('DEBUG',"mailsession - jbossInstallDir=${jbossInstallDir}")
        Logger.log('DEBUG',"mailsession - servername=${servername}")
        Logger.log('DEBUG',"mailsession - mailsession name=${name}")
        
		def configFile = new String("${jbossInstallDir}/standalone/configuration/${servername}.xml")
		Logger.log('DEBUG',"config file is "+configFile)
		
		def oldText = "xmlns=\""+versionNameSpaces[versionName]+"\""
		//def oldText = 
		def newText = "sasid=\"mailSession\""
		updateFile(oldText,newText,configFile)
		def mailSessionParser = new Parser(configFile)
		
		//find mail subsystem node, if not found create one.
		Node mailSessionSubSystemNode = mailSessionParser.findNode("//subsystem[@sasid='mailSession']")
		if(mailSessionSubSystemNode==null){
			def profileNode = mailSessionParser.findNode("//profile")
			mailSessionSubSystemNode = mailSessionParser.addNode("subsystem", "", profileNode)
			mailSessionParser.addAttribute("sasid", "mailSession", mailSessionSubSystemNode)
		}
		
		//find mail session node with the specified jndi name, if not found it is ok. if found remove it and create a new one
        def mailSessionNode = mailSessionParser.findNode("//mail-session[@jndi-name='${jndiname}']")
		if(mailSessionNode!=null){
			mailSessionParser.removeNode(mailSessionNode)
		}
		mailSessionNode = mailSessionParser.addNode("mail-session","",mailSessionSubSystemNode)
		mailSessionParser.addAttribute("jndi-name",jndiname,mailSessionNode)
		//create a smtp-server
		def mailServerNode = mailSessionParser.addNode("smtp-server","",mailSessionNode)
		mailSessionParser.addAttribute("outbound-socket-binding-ref","sas-mail-smtp",mailServerNode)
		
		//create login for mail session
		if(user!=null&&password!=null){
			loginNode = mailSessionParser.addNode("login", "", mailServerNode)
			mailSessionParser.addAttribute("name", name, loginNode)
			mailSessionParser.addAttribute("password", password, loginNode)
		}
		if(mailSessionNode==null){
			println "mail session node is null"
			Logger.log('DEBUG',"mail session node is null")
		}else{
		println "mail session node is not null"
		    Logger.log('DEBUG',"mail session node is not null")
			println mailSessionNode.getChildNodes()
		}
		//update <socket-binding-group default-interface="public" name="standard-sockets">
		
		def socketBindingGroupNode = mailSessionParser.findNode("//socket-binding-group[@name='standard-sockets']")
		def outboundSocketBoundNode = mailSessionParser.findNode("//socket-binding-group[@name='standard-sockets']/outbound-socket-binding[@name='sas-mail-smtp']")
		if(outboundSocketBoundNode!=null){
			mailSessionParser.removeNode(outboundSocketBoundNode)
		}
		outboundSocketBoundNode = mailSessionParser.addNode("outbound-socket-binding", "", socketBindingGroupNode)
		mailSessionParser.addAttribute("name", "sas-mail-smtp", outboundSocketBoundNode)
		def remoteDestinationNode = mailSessionParser.addNode("remote-destination", "", outboundSocketBoundNode)
		mailSessionParser.addAttribute("host", mailhost, remoteDestinationNode)
		mailSessionParser.addAttribute("port", "25", remoteDestinationNode)
		
		mailSessionParser.output(configFile)
		updateFile(newText,oldText,configFile)
        //createWrapperScript(mailsessionFile, jndiname, mailhost, user, password)
		
         }
         catch (Throwable e) {
             Logger.log('DEBUG', "Failure : " + e.toString());
             e.printStackTrace();
             return 8;
         }
         return 0;
    }   
	
	int changeHost(String instance, Properties scriptProperties){
		try {

		Logger.log('DEBUG', "mailsession - ChangeHost ${name}")

		name = scriptProperties.get("mailsession."+instance+".name")
		jndiname = scriptProperties.get("mailsession."+instance+".jndiname")
		mailhost = scriptProperties.get("mailsession."+instance+".mailhost")
		user = scriptProperties.get("mailsession."+instance+".user")
		password = scriptProperties.get("mailsession."+instance+".password")
		servername = scriptProperties.get("mailsession."+instance+".servername")
		def jbossInstallDir = scriptProperties.'config.jboss.install.dir'

		Logger.log('DEBUG',"mailsession - jbossInstallDir=${jbossInstallDir}")
		Logger.log('DEBUG',"mailsession - servername=${servername}")
		Logger.log('DEBUG',"mailsession - mailsession name=${name}")
		
		def mailsessionFile = new String("${jbossInstallDir}/server/${servername}/deploy/${name}.xml")
		if (mailhost)
		{
			def mailsessionParser = new Parser(mailsessionFile)
			def mailhostNode = mailsessionParser.findNode("//server/mbean/attribute[@name='Configuration']/configuration/property[@name='mail.smtp.host']")
			if (mailhostNode)
			{
				Logger.log('DEBUG', "mailsession - updating mailhost with $mailhost")
				mailsessionParser.addAttribute("value",mailhost, mailhostNode)
				mailsessionParser.output(mailsessionFile)
			}
			else
			{
				Logger.log('DEBUG', "mailsession - can't locate mailhost node.")
				Logger.log('DEBUG', "mailsession - won't update mailhost.")
			}
		}
		else
		{
			Logger.log('DEBUG', "mailsession - no mailhost found in scripting properties")
		}

			
		 }
		 catch (Throwable e) {
			 Logger.log('DEBUG', "Failure : " + e.toString());
			 e.printStackTrace();
			 return 8;
		 }
		 return 0;
	}


 def updateFile(oldText,newText,file){
	 Map<String,String> replaceMap = new HashMap<String,String>()
	 replaceMap.put(oldText, newText)
	 Utils.replace (new File(file), replaceMap)

 }
}