package com.sas.config.jboss

import java.util.Properties;

class Queue47 extends Resource{
	String resourceType = "queue"
	String name;
	String jndiname;
	String servername;
	Queue47() {

	}
	Queue47(String c,String j, String s){
		name = c
		jndiname = j
		servername = s
	}
	int configure(String instance, Properties scriptProperties){
		Logger.log('DEBUG', "queue - Configuring ${instance}")

		name = scriptProperties.get("queue."+instance+".name")
		jndiname = scriptProperties.get("queue."+instance+".jndiname")
		servername = scriptProperties.get("queue."+instance+".servername")
		
	    def jbossInstallDir = scriptProperties.'config.jboss.install.dir' 
		def configFile = jbossInstallDir+"/standalone/configuration/"+servername+".xml" 
		def parser = new Parser(configFile) 
		def destinationsNode = parser.findNode("//jms-destinations") 
		def destinationNode = parser.findNode("//jms-destinations/jms-queue[@name='"+name+"']")    
		if(destinationNode!=null){
			parser.removeNode(destinationNode)
		} 
		destinationNode = parser.addNode("jms-queue", "", destinationsNode)   
		parser.addAttribute("name", name, destinationNode)
		def entryNode = parser.addNode("entry", "", destinationNode)
		parser.addAttribute("name", jndiname, entryNode)
		parser.output(configFile)
		return 0 
	}
}
