// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.jboss

import javax.xml.parsers.DocumentBuilderFactory
import javax.xml.parsers.DocumentBuilder
import javax.xml.transform.dom.DOMSource
import javax.xml.transform.stream.StreamResult
import javax.xml.transform.TransformerFactory
import javax.xml.transform.Transformer
import javax.xml.transform.OutputKeys
import javax.xml.xpath.XPathFactory
import javax.xml.xpath.XPathConstants
import org.w3c.dom.Document
import org.w3c.dom.Node
//import org.apache.commons.io.FileUtils

class Connectionfactory47 extends Resource {

	String resourceType = "connectionfactory"
	String name;
	String jndiname;
	String useNamingAlias;
	String maxConnections;
	String servername;
	String messagingDir;

	Connectionfactory47() {}
	Connectionfactory47(String c,String j, String s, String n, String m){
		name = c
		jndiname = j
		servername = s
		useNamingAlias = n
		maxConnections = m
	}

	/*
	 connectionfactory.cf1.name=SAS Queue Factory
	 connectionfactory.cf1.jndiname=sas/jms/QueueConnectionFactory
	 connectionfactory.cf1.servername=SASServer1
	 */
	int configure(String instance, Properties scriptProperties){

       
		Logger.log('DEBUG', "connectionfactory - Configuring ${name}")
		name = scriptProperties.get("connectionfactory."+instance+".name")
		jndiname = scriptProperties.get("connectionfactory."+instance+".jndiname")
		servername = scriptProperties.get("connectionfactory."+instance+".servername")
		//messagingDir = scriptProperties.get("connectionfactory."+instance+".messagingDir")
		def configFile = servername+".xml"
		def jbossInstallDir = scriptProperties.'config.jboss.install.dir'
		def connectionfactoryFile
		def connectionfactoryParser
		connectionfactoryFile = new String("$jbossInstallDir/standalone/configuration/$configFile")
		connectionfactoryParser = new Parser(connectionfactoryFile)
		def connectionsFactorysNode = connectionfactoryParser.findNode("//jms-connection-factories")
		def connectionsFactoryNode = connectionfactoryParser.findNode("//jms-connection-factories/connection-factory[@name='$name']")
		if(connectionsFactoryNode!=null){
			connectionfactoryParser.removeNode(connectionsFactoryNode)
		}
		connectionsFactoryNode = connectionfactoryParser.addNode("connection-factory","",connectionsFactorysNode)
		connectionfactoryParser.addAttribute("name", name, connectionsFactoryNode)
		def connectorsNode = connectionfactoryParser.addNode("connectors", "", connectionsFactoryNode)
		//def connectorRefNodeInVm = connectionfactoryParser.addNode("connector-ref","",connectorsNode)
		//connectionfactoryParser.addAttribute("connector-name", "in-vm", connectorRefNodeInVm)
		def connectorRefNodeNetty = connectionfactoryParser.addNode("connector-ref","",connectorsNode)
		connectionfactoryParser.addAttribute("connector-name", "netty", connectorRefNodeNetty)
		
		def entriesNode = connectionfactoryParser.addNode("entries","",connectionsFactoryNode)
		def entryNode = connectionfactoryParser.addNode("entry","",entriesNode)
		connectionfactoryParser.addAttribute("name", jndiname, entryNode)
		entryNode = connectionfactoryParser.addNode("entry","",entriesNode)
		connectionfactoryParser.addAttribute("name", "java:jboss/exported/"+jndiname, entryNode)
		
		connectionfactoryParser.output(connectionfactoryFile)
		return 0;
	}


}