// Copyright (c) 2002-2011, SAS Institute Inc., Cary, NC, USA, All Rights Reserved

package com.sas.config.jboss

import java.lang.reflect.Method
import java.util.Map;

import javax.xml.parsers.DocumentBuilderFactory
import javax.xml.parsers.DocumentBuilder
import javax.xml.transform.dom.DOMSource
import javax.xml.transform.stream.StreamResult
import javax.xml.transform.TransformerFactory
import javax.xml.transform.Transformer
import javax.xml.transform.OutputKeys
import javax.xml.xpath.XPathFactory
import javax.xml.xpath.XPathConstants
import org.w3c.dom.Document
import org.w3c.dom.Node
import org.w3c.dom.NodeList
import com.sas.config.util.Chmod

//import org.apache.commons.io.FileUtils

class JBossServer7  extends Resource
{

    String resourceType = "server"

    String name;
    String httpport;
    Boolean jmssecurity;
    String jmssecurityuser;
    String jmssecuritypw;
	String encoding;
    String jvm_option_list;
    String wrapperdir;
    String portIncrement;
    String serverSource;
    String versionName ;
    Collection<String> options;
    Collection<Loginmodule> loginmodules;
    Collection<Policy> policies;
    Collection<Connectionfactory> connectionfactories;
    Collection<Queue> queues;
    Collection<Topic> topics;
    Collection<Datasource> datasources;
	Collection<JDBCProvider> jdbcproviders;
    Collection<Mailsession> mailsessions;
    Collection<Application> applications;
    Collection<Externalcontext> externalcontexts;
    JBossServer7() {}
    
   
    /* 
     server.server1.name=SASServer1 
     server.server1.portIncrement=0
     server.server1.options=-Xms768m,-Xmx768m,-DSpecialOptionWithSpaces="This option has spaces",-Xss128k,-Xmso32k,-Xgcpolicy:optavgpause,-Djavax.management.builder.initial=,-Dcom.sun.management.jmxremote,-Dsun.rmi.dgc.client.gcInterval=3600000,-Dsun.rmi.dgc.server.gcInterval=3600000,-Djava.awt.headless=true,-Dsas.container.identifier=websphere,-Dsas.auto.publish.port=9080,-Dcom.sas.services.logging.disableRemoteList=true,-Dcom.sas.services.logging.disableRemoteLogging=true,-Djava.net.preferIPv4Stack=true,-Djava.net.preferIPv6Addresses=false,-Dmulticast_udp_ip_ttl=32,-Dmulticast.address=239.12.11.244,-Dmulticast.port=8561,-Dcom.sas.log.config.url=file:///D:/config/Lev1/Web/Common/LogConfig/
     server.server1.source=[all,default]
     server.server1.transaction=[JTS,] (not used for "default")
     server.server1.jmssecurity=[true,false,]
     server.server1.jmssecurity.user=[sasJmsUser,,]
     server.server1.jmssecurity.password=[sasJmsPW,,]
     
	 config.jboss.install.dir=C:\\jboss\\jboss-eap-5.0\\jboss-as
	 config.jdk.install.dir=C:\\Java\\jdk1.6.0_18
	 config.jboss.bind.host=d71067.na.sas.com
     */
    int configure(String instance, Properties scriptProperties){
        try {

        Logger.log('LOG', "server - Configuring ${instance}")
       
        name = scriptProperties.get("server."+instance+".name")  
        jvm_option_list = scriptProperties.get("server."+instance+".options") 
		jvm_option_list = jvm_option_list.replaceAll("-Dcom.sun.management.jmxremote;","")
		jvm_option_list = jvm_option_list.replaceAll("-Djboss.platform.mbeanserver;","")
		jvm_option_list = jvm_option_list.replaceAll("-Djavax.management.builder.initial=org.jboss.system.server.jmx.MBeanServerBuilderImpl;","")
		jvm_option_list = jvm_option_list.replaceAll("-Dcom.sun.management.jmxremote","")
		jvm_option_list = jvm_option_list.replaceAll("-Djboss.platform.mbeanserver","")
		jvm_option_list = jvm_option_list.replaceAll("-Djavax.management.builder.initial=org.jboss.system.server.jmx.MBeanServerBuilderImpl","")
		
		jvm_option_list = jvm_option_list + ";-Dorg.apache.tomcat.util.http.ServerCookie.FWD_SLASH_IS_SEPARATOR=false"

        portIncrement = scriptProperties.get("server."+instance+".portIncrement")
        
        def jbossBindHost = scriptProperties.get("config.jboss.bind.host")
        def jbossInstallDir = scriptProperties.get("config.jboss.install.dir")
        def jdkInstallDir = scriptProperties.get("config.jdk.install.dir")
        wrapperdir = scriptProperties.get("config.tanuki.wrapper.dir")
        def configHostType = scriptProperties.get("config.host.type")
        
        serverSource = scriptProperties.get("server."+instance+".source")
        def transaction = scriptProperties.get("server."+instance+".transaction")
        def jmsSecurity = scriptProperties.get("server."+instance+".jmssecurity")
        def jmsSecurityUser = scriptProperties.get("server."+instance+".jmssecurity.user")
        def jmsSecurityPW = scriptProperties.get("server."+instance+".jmssecurity.password")
		def encoding = scriptProperties.get("server."+instance+".jmssecurity.encoding")
        def allPolicyFile = scriptProperties.get("server."+instance+".all.policy.file")
        def restrictivePolicyFile = scriptProperties.get("server."+instance+".restrictive.policy.file")
        def jbossNamingPort
//        def messagingDir = scriptProperties.get("server."+instance+".messagingDir")
        def jbossServiceDependency = scriptProperties.get("server."+instance+".service.dependency")
        
        def multicastAutoToken = ""        
//        def version = new JBossVersion(jbossInstallDir+"/bin/run.jar") 
		def version = new JBossVersion(jbossInstallDir)
		def messagingDir = version.getMessagingDir()
		
        Logger.log('DEBUG',"server - jbossInstallDir=${jbossInstallDir}")
        Logger.log('DEBUG',"server - jdkInstallDir=${jdkInstallDir}")
        Logger.log('DEBUG',"server - wrapperDir=${wrapperdir}")
        Logger.log('DEBUG',"server - servername=${name}")
        Logger.log('DEBUG',"server - portIncrement=${portIncrement}")
        Logger.log('DEBUG',"server - options=${jvm_option_list}")
        Logger.log('DEBUG',"server - source=${serverSource}")
        Logger.log('DEBUG',"server - transaction=${transaction}")
		
		def targetDir = jbossInstallDir+"/standalone/configuration/"
		Ant.copyFile(targetDir+"standalone.xml",targetDir+name+".xml", "true")
		Ant.copyFile(jbossInstallDir+"/bin/"+"standalone.bat", jbossInstallDir+"/bin/"+name+"_standalone.bat", "true")
		Ant.copyFile(jbossInstallDir+"/bin/"+"standalone.sh", jbossInstallDir+"/bin/"+name+"_standalone.sh", "true")
        //Logger.log('DEBUG',"DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD")
        //Configure new port bindings for server and modify based on properties
        Logger.log('DEBUG', "server - calling JBossPorts($instance,$name,$portIncrement,"+version.getVersion()+", scriptProperties)")
        JBoss7Ports ports = new JBoss7Ports(instance,name,portIncrement,version.getVersion(), scriptProperties)
		updateLogFilePath(targetDir+name+".xml",name)
		
		if (jbossBindHost == null){
			jbossBindHost = "0.0.0.0"
		}
		createJMSConfiguration(targetDir+name+".xml",scriptProperties)
		createWebServiceConfiguration(targetDir+name+".xml",scriptProperties)
		updatePublicInterface(targetDir+name+".xml",jbossBindHost)
		def newValue = '''<wsdl-host>\\${jboss.bind.address:'''+jbossBindHost+'''}</wsdl-host>'''
        updateFile("replace-wsdl-host",newValue,targetDir+name+".xml")
		def applicationUsersFile = new String("$jbossInstallDir/standalone/configuration/$instance-application-users.properties")
		def applicationRolesFile = new String("$jbossInstallDir/standalone/configuration/$instance-application-roles.properties")
		def managementUsersFile = new String("$jbossInstallDir/standalone/configuration/$instance-mgmt-users.properties")
		def managementRolesFile = new String("$jbossInstallDir/standalone/configuration/$instance-mgmt-roles.properties")
		updateFile("application-users.properties","$instance-application-users.properties",targetDir+name+".xml")
		updateFile("application-roles.properties","$instance-application-roles.properties",targetDir+name+".xml")
		updateFile("mgmt-users.properties","$instance-mgmt-users.properties",targetDir+name+".xml")
		updateFile("mgmt-roles.properties","$instance-mgmt-roles.properties",targetDir+name+".xml")
		//Save off original list of options for wrapper
		def wrapper_option_list = jvm_option_list
        
		//Create Custom JBoss startup script ie. SASServer1.[bat,sh]
		
		//clean up -Dhttp.nonProxyHosts="...|...|..." option.  If using "eval" invocation, need to escape the 
		//use of quotes and pipes in options.
		

        createBatchScript(name,version,jbossInstallDir,jdkInstallDir,jvm_option_list,"", jbossBindHost, configHostType, jbossNamingPort)
		File wrapperdirFile = null
		if(wrapperdir!=null){
			wrapperdirFile = new File(wrapperdir)
		}
		if (configHostType == "win" && wrapperdirFile != null && wrapperdirFile.exists()){
			
			def serviceDirPath = jbossInstallDir+"/service"
			Ant.mkdir(serviceDirPath)
			Logger.log('DEBUG',"server - grab wrapper parts")
			
			
			File wrapperExe = new File(serviceDirPath,"wrapper.exe");
			if ( wrapperExe.exists() ) {
				Logger.log('DEBUG',"server - found wrapper parts, no need to copy")
			} else {
				Logger.log('DEBUG',"server - grab wrapper parts")
				['wrapper.exe','wrapper.dll','wrapper.jar'].each{Ant.copyFile(wrapperdir+"/"+it, serviceDirPath+"/"+it, "true")}
			}
	
			wrapper_option_list = wrapper_option_list + ";-Dorg.jboss.boot.log.file=$jbossInstallDir\\standalone\\log\\boot.log"
			wrapper_option_list = wrapper_option_list + ";-Dlogging.configuration=file:$jbossInstallDir\\standalone\\configuration\\logging.properties"
			wrapper_option_list = wrapper_option_list + ";-Djboss.home.dir=$jbossInstallDir"
			
			wrapper_option_list = wrapper_option_list + ";-Dorg.jboss.resolver.warning=true"
			wrapper_option_list = wrapper_option_list + ";-Djboss.modules.system.pkgs=org.jboss.byteman"
			
		
			createWrapperScript(name,version,jbossInstallDir,jdkInstallDir,wrapper_option_list,jbossServiceDependency,jbossBindHost)
			
			
			
			Logger.log('DEBUG',"server - remove service")
			Logger.log('DEBUG',"server - remove service: Ant.exec(jbossInstallDir, 'cmd', '/c start \"JBoss Application Server: '+name+'\" /wait /B \"'+jbossInstallDir+'\\bin\\'+name+'.bat\" -remove')")
			Ant.exec(jbossInstallDir, 'cmd', '/c start "JBoss Application Server: '+name+'" /wait /B "'+jbossInstallDir+'\\bin\\'+name+'.bat" -remove')

			Logger.log('DEBUG',"server - install service")
			Logger.log('DEBUG',"server - install service: Ant.exec(jbossInstallDir, 'cmd', '/c start \"JBoss Application Server: '+name+'\" /wait /B \"'+jbossInstallDir+'\\bin\\'+name+'.bat\" -install')")
			Ant.exec(jbossInstallDir, 'cmd', '/c start "JBoss Application Server: '+name+'" /wait /B "'+jbossInstallDir+'\\bin\\'+name+'.bat" -install')

		}
		createUserScript(managementUsersFile,"","")
		// Tune jms security if needed
		if (jmsSecurity == "true"){
		  jmsSecurityPW = getEncodedPassword(jmsSecurityUser, jmsSecurityPW,"ApplicationRealm",jbossInstallDir)
		  createUserScript(applicationUsersFile,jmsSecurityUser,jmsSecurityPW)
		  createRoleScript(applicationRolesFile,jmsSecurityUser,"JMSUser")
		  def configFile = new String("$jbossInstallDir/standalone/configuration/${name}.xml")
		  updateSecuritySettingRoles("JMSUser",configFile)
		}else{
		  createRoleScript(applicationRolesFile,"guest","guest")
		  createUserScript(applicationUsersFile,"","")
		  def configFile = new String("$jbossInstallDir/standalone/configuration/${name}.xml")
		  Parser configFileParser = new Parser(configFile)
		  def loginModuleNode = configFileParser.findNode("//security-domains/security-domain[@name='other']/authentication/login-module[@code='RealmUsersRoles']")
		  Node moduleOptionNode = configFileParser.findNode("//security-domains/security-domain[@name='other']/login-module[@code='RealmUsersRoles']/module-option[@name='unauthenticatedIdentity']")
		  if(moduleOptionNode==null){
			  moduleOptionNode = configFileParser.addNode("module-option", "", loginModuleNode)
			  configFileParser.addAttribute("name", "unauthenticatedIdentity", moduleOptionNode)
			  configFileParser.addAttribute("value", "guest", moduleOptionNode)
			  System.out.println(configFile);
			  configFileParser.output(configFile)

		  }
		 }
		 
		 // remove securityRealm from remoting-connector
		
		updateFile("security-realm=\"ApplicationRealm\"","",targetDir+name+".xml")
		updateJstlApiModule(jbossInstallDir)
		
         // Tune log4j categories
		 //def log4jConfigFile = new String("$jbossInstallDir/standalone/configuration/${name}.xml")
		 //def jbossLog4jXmlFile = new Parser()
		 //jbossLog4jXmlFile.parse(log4jConfigFile)
		 
		 //add jacorb
		 
		 def oldDomainEE = "<subsystem xmlns=\"urn:jboss:domain:ee:1.0\"/>"
		 def newDomainEE = '''
		                   <subsystem xmlns="urn:jboss:domain:ee:1.0" >              
                              <global-modules>    
                                  <module name="org.javassist" slot="main" /> 
                                  <module name="org.jacorb" slot="main" />    
                                  <module name="org.hornetq" slot="main"/>
                                  <module name="org.jboss.ironjacamar.jdbcadapters" slot="main"/>
                                  <module name="org.jboss.as.jmx" slot="main"/>
                                  <module name="org.apache.xerces" slot="main"/>                                   
                                  <module name="org.omg.api" slot="main" /> 
                                  <module name="org.apache.log4j" slot="main" />
                              </global-modules> 
                           </subsystem>
                           '''
		 updateFile(oldDomainEE,newDomainEE,targetDir+name+".xml")
		
         // Add deploy_sas deployment directory      
         String deployDirName = new String("deploy_sas")
         String deployDirPath = new String("$jbossInstallDir/standalone/deployments/$deployDirName/${name}")
		 deployDirPath = deployDirPath.replaceAll("\\\\","/")
         def deployDir = new File(deployDirPath)
         deployDir.mkdirs()

		 // Turn off deploy scanner
		 def sasConfigFile = new String("$jbossInstallDir/standalone/configuration/${name}.xml")
		 Parser sasConfigFileParser = new Parser(sasConfigFile)
		 def deployScannerNode = sasConfigFileParser.findNode("//deployment-scanner")
		 sasConfigFileParser.addAttribute("auto-deploy-zipped", "false", deployScannerNode)
		 sasConfigFileParser.addAttribute("auto-deploy-exploded", "false", deployScannerNode)
		 sasConfigFileParser.addAttribute("scan-enabled", "false", deployScannerNode)
		 sasConfigFileParser.output(sasConfigFile)
		 updateFile("path=\"deployments\"","path=\"deployments/$deployDirName/${name}\"",targetDir+name+".xml")
        
         //copy policy files.  The jvm options may use one or the other, place both in conf for safe keeping
         if (allPolicyFile != null)
             Ant.copyFileToDir(allPolicyFile,"$jbossInstallDir/server/$name/conf","true")
         //If we can't find the specific restrictive policy file, don't worry about it. (4th parm is ignore fail)
         if (restrictivePolicyFile != null)
             Ant.copyFileToDir(restrictivePolicyFile,"$jbossInstallDir/server/$name/conf","true","false")

		 String destination = "$jbossInstallDir/modules/org/apache/xalan/main"             
		 updateJarFile("xalan-2.7.1.jbossorg-1.jar",destination)

		  /* Set SessionCookie path to use root as default instead of /context so Portal can function. 
		   * Only for Jboss 5 or higher, as jboss changed the default. see S0782643 */
         }
         catch (Throwable e) {
             Logger.log('DEBUG', "Failure : " + e.toString());
             e.printStackTrace();
             return 8;
         }
         return 0;
    }  
def createExtension(String moduleName,String file){
	 def parser = new Parser(file)
	 def entensionsNode = parser.findNode("//extensions")
	 def entensionNode = parser.findNode("//extensions/extension[@module='"+moduleName+"']")
	 if(entensionNode==null){
		 entensionNode = parser.addNode("extension", "", entensionsNode)
		 parser.addAttribute("module", moduleName, entensionNode)
		 parser.output(file)
	 }
	} 
def createWebServiceConfiguration(String file,Properties scriptProperties){
	Map versionNameSpaces = [
		'7.0' : "urn:jboss:domain:webservices:1.0" ,
		'7.1' : "urn:jboss:domain:webservices:1.1"
	]
	versionName = scriptProperties.get("config.appserver.version")
	versionName = versionName.substring(0,3)
	createExtension("org.jboss.as.messaging",file)
	def oldText = "xmlns=\""+versionNameSpaces[versionName]+"\""
	def newText = "sasid=\"webservices\""
	updateFile(oldText,newText,file)
    def webservicesConfig='''
       <modify-wsdl-address>true</modify-wsdl-address>
       replace-wsdl-host
       <endpoint-config name="Standard-Endpoint-Config"/>
       <endpoint-config name="Recording-Endpoint-Config">
          <pre-handler-chain name="recording-handlers" protocol-bindings="##SOAP11_HTTP ##SOAP11_HTTP_MTOM ##SOAP12_HTTP ##SOAP12_HTTP_MTOM">
             <handler class="org.jboss.ws.common.invocation.RecordingServerHandler" name="RecordingHandler"/>
          </pre-handler-chain>
       </endpoint-config>

    '''
	def parser = new Parser(file)
	def profileNode = parser.findNode("//profile")
	def webservicesNode = parser.findNode("//subsystem[@sasid='webservices']")
	if(webservicesNode!=null){
		parser.removeNode(webservicesNode)
	 }
	webservicesNode = parser.addNode("subsystem","",profileNode)
	parser.addAttribute("sasid", "webservices", webservicesNode)
	parser.addTextNode("replace messaging", webservicesNode)
	parser.output(file)
	updateFile("replace messaging",webservicesConfig,file)
	updateFile(newText,oldText,file)

}
def createJMSConfiguration(String file,Properties scriptProperties){
	//<subsystem xmlns="urn:jboss:domain:messaging:1.1">
    Map versionNameSpaces = [
		'7.0' : "urn:jboss:domain:messaging:1.0" ,
		'7.1' : "urn:jboss:domain:messaging:1.1"
    ]
    versionName = scriptProperties.get("config.appserver.version")
	versionName = versionName.substring(0,3)
	createExtension("org.jboss.as.messaging",file)
    def oldText = "xmlns=\""+versionNameSpaces[versionName]+"\""
	def newText = "sasid=\"messaging\""
	updateFile(oldText,newText,file)
	def jmsConfig ='''\r\n
	  <hornetq-server>\r\n
		<persistence-enabled>true</persistence-enabled>\r\n
		<journal-file-size>102400</journal-file-size>\r\n
		<journal-min-files>2</journal-min-files>\r\n

		<connectors>\r\n
			<netty-connector name="netty" socket-binding="messaging"/>\r\n
			<netty-connector name="netty-throughput" socket-binding="messaging-throughput">\r\n
				<param key="batch-delay" value="50"/>\r\n
			</netty-connector>\r\n
			<in-vm-connector name="in-vm" server-id="0"/>\r\n
		</connectors>\r\n

		<acceptors>\r\n
			<netty-acceptor name="netty" socket-binding="messaging"/>\r\n
			<netty-acceptor name="netty-throughput" socket-binding="messaging-throughput">\r\n
				<param key="batch-delay" value="50"/>\r\n
				<param key="direct-deliver" value="false"/>\r\n
			</netty-acceptor>\r\n
			<in-vm-acceptor name="in-vm" server-id="0"/>\r\n
		</acceptors>\r\n

		<security-settings>\r\n
			<security-setting match="#">\r\n
				<permission type="send" roles="guest"/>\r\n
				<permission type="consume" roles="guest"/>\r\n
				<permission type="createNonDurableQueue" roles="guest"/>\r\n
				<permission type="deleteNonDurableQueue" roles="guest"/>\r\n
			</security-setting>\r\n
		</security-settings>\r\n

		<address-settings>\r\n
			<address-setting match="#">\r\n
				<dead-letter-address>jms.queue.DLQ</dead-letter-address>\r\n
				<expiry-address>jms.queue.ExpiryQueue</expiry-address>\r\n
				<redelivery-delay>0</redelivery-delay>\r\n
				<max-size-bytes>10485760</max-size-bytes>\r\n
				<address-full-policy>BLOCK</address-full-policy>\r\n
				<message-counter-history-day-limit>10</message-counter-history-day-limit>\r\n
			</address-setting>\r\n
		</address-settings>\r\n

		<jms-connection-factories>\r\n
			<connection-factory name="InVmConnectionFactory">\r\n
				<connectors>\r\n
					<connector-ref connector-name="in-vm"/>\r\n
				</connectors>\r\n
				<entries>\r\n
					<entry name="java:/ConnectionFactory"/>\r\n
				</entries>\r\n
			</connection-factory>\r\n
			<connection-factory name="RemoteConnectionFactory">\r\n
				<connectors>\r\n
					<connector-ref connector-name="netty"/>\r\n
				</connectors>\r\n
				<entries>\r\n
					<entry name="RemoteConnectionFactory"/>\r\n
					<entry name="java:jboss/exported/jms/RemoteConnectionFactory"/>\r\n
				</entries>\r\n
			</connection-factory>\r\n
			<pooled-connection-factory name="hornetq-ra">\r\n
				<transaction mode="xa"/>\r\n
				<connectors>\r\n
					<connector-ref connector-name="in-vm"/>\r\n
				</connectors>\r\n
				<entries>\r\n
					<entry name="java:/JmsXA"/>\r\n
				</entries>\r\n
			</pooled-connection-factory>\r\n
		</jms-connection-factories>\r\n

		<jms-destinations>\r\n
			<jms-queue name="testQueue">\r\n
				<entry name="queue/test"/>\r\n
				<entry name="java:jboss/exported/jms/queue/test"/>\r\n
			</jms-queue>\r\n
			<jms-topic name="testTopic">\r\n
				<entry name="topic/test"/>\r\n
				<entry name="java:jboss/exported/jms/topic/test"/>\r\n
			</jms-topic>\r\n
		</jms-destinations>\r\n
	</hornetq-server>\r\n
'''
	def parser = new Parser(file)
	def profileNode = parser.findNode("//profile")
	def messagingNode = parser.findNode("//subsystem[@sasid='messaging']")
	if(messagingNode!=null){
		parser.removeNode(messagingNode)
	 }
	messagingNode = parser.addNode("subsystem","",profileNode)
	parser.addAttribute("sasid", "messaging", messagingNode)
	parser.addTextNode("replace messaging", messagingNode)
	parser.output(file)
	updateFile("replace messaging",jmsConfig,file)
	updateFile(newText,oldText,file)
	}
def updateSecuritySettingRoles(String role,String file){
	addPermissionNode("send",role,file)
	addPermissionNode("consume",role,file)
	addPermissionNode("createNonDurableQueue",role,file)
	addPermissionNode("deleteNonDurableQueue",role,file)
	}
def addPermissionNode(String type,String role,String file){
	def parser = new Parser(file)
	def securitySettingNode = parser.findNode("//security-setting[@match='#']")
	def permissionNode = parser.findNode("//security-setting[@match='#']/permission[@type='"+type+"']")
	if(permissionNode!=null){
		parser.removeNode(permissionNode)
	}
	permissionNode = parser.addNode("permission","",securitySettingNode)
	parser.addAttribute("type", type, permissionNode)
	parser.addAttribute("roles", role, permissionNode)
	parser.output(file)
	}
def createUserScript(
        String filename,
        String username,
        String password
    ){  
    def wrapperScript = '''#
# user=password
#
$username=$password
    '''      
       def engine = new groovy.text.SimpleTemplateEngine()
       def template = engine.createTemplate(wrapperScript)
       def decodedpassword = null
       if (password!= null)
            decodedpassword = com.sas.util.SasPasswordString.decode(password)
       def binding = [
           username : username,
           password : decodedpassword, 
             ]
       def scriptOut = template.make(binding)
       def outFile = new File(filename)
       outFile.write(scriptOut.toString())        
}
def createRoleScript(
        String filename,
        String username,
		String rolename
    ){  
    def wrapperScript = '''#
# user=role1,role2,...
#
$username=$rolename
    '''      
       def engine = new groovy.text.SimpleTemplateEngine()
       def template = engine.createTemplate(wrapperScript)
       def binding = [
           username : username,
		   rolename : rolename,
             ]
       def scriptOut = template.make(binding)
       def outFile = new File(filename)
       outFile.write(scriptOut.toString())        
}
    

//
//createBatchScript()
//TODO : implement the multicastAuthToken, not currently in the script code...
//TODO : implement the createShellScript() method for unix...
//
void createBatchScript(
  String servername,
  JBossVersion version,
  String jbossInstallDir,
  String jdkInstallDir,
  String jvmOptionsList,
  String multicastAuthToken,
  String jbossBindHost,
  String configHostType,
  String jbossNamingPort
){  
  def runBatScript='''
@echo off
rem -------------------------------------------------------------------------
rem JBoss Bootstrap Script for Win32
rem -------------------------------------------------------------------------

setlocal


set SERVICENAME=JBoss - $servername
set JBOSS_BIN_DIR=$jbossInstallDir\\\\bin
set SERVERNAME=$servername
set WRAPPER_DIR=$jbossInstallDir\\\\service

if x%1 EQU x goto start_as_script
if %1 EQU install goto install
if %1 EQU remove goto remove
if %1 EQU start goto start
if %1 EQU stop goto stop
if %1 EQU restart goto restart
if %1 EQU pause goto pause
if %1 EQU resume goto resume
if %1 EQU status goto status
if %1 EQU -install goto install
if %1 EQU -remove goto remove
if %1 EQU -start goto start
if %1 EQU -stop goto stop
if %1 EQU -restart goto restart
if %1 EQU -pause goto pause
if %1 EQU -resume goto resume
if %1 EQU -status goto status
goto usage


:install
 start /b /wait "JBoss - $servername" "%WRAPPER_DIR%\\\\Wrapper.exe" -i "%WRAPPER_DIR%\\\\%SERVERNAME%\\\\wrapper.conf"
 if %ERRORLEVEL% == 0 echo JBoss server installed as a service
 goto end
:remove
 start /b /wait "JBoss - $servername" "%WRAPPER_DIR%\\\\Wrapper.exe" -r "%WRAPPER_DIR%\\\\%SERVERNAME%\\\\wrapper.conf"
 if %ERRORLEVEL% == 0 echo JBoss server removed as a service
 goto end
:start
 net start "%SERVICENAME%"
 if %ERRORLEVEL% == 0 echo JBoss server started as a service
 goto end
:stop
 net stop "%SERVICENAME%"
 if %ERRORLEVEL% == 0 echo JBoss server stopped as a service
 goto end
:restart
 net stop "%SERVICENAME%"
 if %ERRORLEVEL% == 0 echo JBoss server stopped as a service
 net start "%SERVICENAME%"
 if %ERRORLEVEL% == 0 echo JBoss server started as a service
 goto end
:pause
 net pause "%SERVICENAME%"
 if %ERRORLEVEL% == 0 echo JBoss server paused as a service
 goto end
:resume
 net continue "%SERVICENAME%"
 if %ERRORLEVEL% == 0 echo JBoss server resumed as a service
 goto end
:status
 sc interrogate "%SERVICENAME%"
 goto end
:usage
 echo USAGE:  %0 {install ^| start ^| stop ^| restart ^| pause ^| resume ^| remove ^| status}
 goto end
 
:start_as_script
set JAVA_HOME=$jdkInstallDir


$multicastAuthToken

"$jbossInstallDir\\\\bin\\\\%SERVERNAME%_standalone.bat" --server-config=%SERVERNAME%.xml 

:end
endlocal
if [%2] EQU [exit] exit %ERRORLEVEL%
'''
  def runShScript='''#!/bin/sh -p
### ====================================================================== ###
##                                                                          ##
##  JBoss Bootstrap Script                                                  ##
##                                                                          ##
### ====================================================================== ###

JAVA_HOME=\"$jdkInstallDir\"
export JAVA_HOME

JAVA_OPTS=\"$jvmOptions\"
export JAVA_OPTS

export JBOSS_PIDFILE=$jbossInstallDir/standalone/server/$servername/log/jboss.pid

SERVERNAME=$servername

$multicastAuthToken

mkdir -p \"$jbossInstallDir/server/$servername/log\"

# Get argument
if [ "\\$1" = "-start" ]; then
   arg=start ; shift
elif [ "\\$1" = "-stop" ]; then
   arg=stop ; shift
elif [ "\\$1" = "-status\" ]; then
   arg=status ; shift
elif [ "\\$1" = "-restart" ]; then
   arg=restart ; shift
elif [ "\\$1" = "-kill" ]; then
   arg=kill ; shift
elif [ "\\$1" = "start" ]; then
   arg=start ; shift
elif [ "\\$1" = "stop" ]; then
   arg=stop ; shift
elif [ "\\$1" = "status" ]; then
   arg=status ; shift
elif [ "\\$1" = "restart" ]; then
   arg=restart ; shift
elif [ "\\$1" = "kill" ]; then
   arg=kill ; shift
elif [ "x\\$1" = "x" ]; then
   arg=startForeground
fi

case "\\$arg" in
   start)
      LAUNCH_JBOSS_IN_BACKGROUND=true
      export LAUNCH_JBOSS_IN_BACKGROUND      
      nohup "$jbossInstallDir/bin/standalone.sh" --server-config=\\${SERVERNAME}.xml \\$@ >"$jbossInstallDir/server/$servername/log/stdout.log" 2>&1 &
      pid=\\$!
      echo \\$pid > "$jbossInstallDir/server/$servername/log/jboss.pid"
      #pid=`cat $jbossInstallDir/server/$servername/log/jboss.pid`
      echo "JBoss startup has begun (pid \\$pid)..."
   ;;
   
   stop)
         if [ -f $jbossInstallDir/server/$servername/log/jboss.pid ]; then
            pid=`cat $jbossInstallDir/server/$servername/log/jboss.pid`
            kill \\$* \\$pid
            if [ \\$? -ne 0 ]; then
               echo "pid: \\$pid"
            fi
         else
             echo "JBoss not running." 
             exit 1
         fi
   ;;
   
   kill)
         if [ -f $jbossInstallDir/server/$servername/log/jboss.pid ]; then
            pid=`cat $jbossInstallDir/server/$servername/log/jboss.pid`
            kill \\$* \\$pid
            if [ \\$? -ne 0 ]; then
               echo "pid: \\$pid"
            fi
         else
             echo "JBoss not running." 
             exit 1
         fi
   ;;
   
   status)
          if [ -f $jbossInstallDir/server/$servername/log/jboss.pid ]; then
            pid=`cat $jbossInstallDir/server/$servername/log/jboss.pid`
            kill -0 \\$pid > /dev/null 2>&1
            if [ \\$? -eq 0 ]; then
               echo "JBoss running (pid \\$pid)"
            else
               echo "JBoss is not running"
            fi
         else
            echo "JBoss is not running"
         fi 
   ;;
   
   restart)
         \\$0 -kill -9
         if [ \\$? -eq 0 ]; then 
            sleep 10
            \\$0 -start
         fi
   
   ;;
   
   startForeground)
        "$jbossInstallDir/bin/standalone.sh" --server-config=\\${SERVERNAME}.xml 
   ;;
   
   *)
         echo "USAGE:  \\$0 { start | stop | restart | status | kill | help}"
         echo "     :  start   - launch JBoss server in the background"
         echo "     :  stop    - issue [JBOSS-HOME]/bin/shutdown.sh to stop JBoss server"
         echo "     :  restart - kill JBoss server process, re-launch server in the background"
         echo "     :  status  - return JBoss server process status (via kill -0 <pid>)"
         echo "     :  help    - display these command options"
         echo "     :  [no arguments passed to the command results in launch of JBoss server in the foreground]"
         echo " "
         
   ;;
esac

exit 0

exit 0
'''

 def jvmOptions = jvmOptionsList.replaceAll(/;/) {' '}
 
 def engine = new groovy.text.SimpleTemplateEngine()
 def template 
 def subscript
 def jvmOptionsVar="JAVA_OPTS"
 if (configHostType == "win") {
    template = engine.createTemplate(runBatScript)
    subscript = ".bat"
	jvmOptions = jvmOptions.replaceAll("\\\\", "\\\\\\\\")
 } else {
    template = engine.createTemplate(runShScript)
    subscript = ".sh"
	//need to clean up pipes in -Dhttp.nonProxyHosts option
	if (jvmOptions.contains("-Dhttp.nonProxyHosts")){
		
	}
 }
 if (version.getVersion() != "4") {
	 jvmOptionsVar = "SAS_JAVA_OPTS"
 }
 
 
 String java_opts = "set JAVA_OPTS="+jvmOptions
 if (configHostType == "win") {
  String bat_file = jbossInstallDir+"/bin/"+name+"_standalone"+subscript
  updateBatJvmOptions(java_opts,"call \"%STANDALONE_CONF%\" %\\*",bat_file)
  updateBatJvmOptions("%JAVA_OPTS%","\"%JAVA_OPTS%\"",bat_file)
  updateBatJvmOptions("%JAVA_OPTS%","%JAVA_OPTS%\"",bat_file)
  updateBatJvmOptions("JAVA_OPTS","\"JAVA_OPTS",bat_file)
  String fullVersion = new JBoss7Version(jbossInstallDir).getJBoss7Version()
  if("7.1.0.Beta1b".equals(fullVersion)){
	  updateBatJvmOptions("-server","-server\\\"",bat_file)
  }
 }else{
  java_opts = "export JAVA_OPTS="+jvmOptions
  String bat_file = jbossInstallDir+"/bin/"+name+"_standalone"+subscript
  updateBatJvmOptions(java_opts,". \"\$RUN_CONF\"",bat_file)
 }

 def binding = [
     servername: servername,
     jbossInstallDir : jbossInstallDir,
     jdkInstallDir : jdkInstallDir,
     jvmOptions : jvmOptions, 
     multicastAuthToken : multicastAuthToken,
     jbossBindHost : jbossBindHost,
     jbossNamingPort : jbossNamingPort,
	 jvmOptionsVar: jvmOptionsVar
       ]
 def scriptOut = template.make(binding)
 def filename = jbossInstallDir+"/bin/"+servername+subscript
 def outFile = new File(filename)
 def rc = outFile.write(scriptOut.toString())
 Logger.log('DEBUG', "createBatchScript - writing $filename returned $rc")
 
 Chmod.file("u+rx", outFile)
 
}


//TODO :  Implement jbossServiceDependency code...not currently in the wrapper...
//#wrapper.ntservice.dependency.1=${services.rmi.service.name}
void createWrapperScript(
      String servername,
      JBossVersion version,
      String jbossInstallDir,
      String jdkInstallDir,
      String jvmOptions,
      String jbossServiceDependency,
      String jbossBindHost
  ){  
  def wrapperScript = '''
#********************************************************************
# Wrapper Properties
#********************************************************************
# Java Application

wrapper.java.command=$jdkInstallDir\\\\bin\\\\java

# Java Main class.  This class must implement the WrapperListener interface
#  or guarantee that the WrapperManager class is initialized.  Helper
#  classes are provided to do this for you.  See the Integration section
#  of the documentation for details.
wrapper.java.mainclass=org.tanukisoftware.wrapper.WrapperSimpleApp

# Java Classpath (include wrapper.jar)  Add class path elements as
#  needed starting from 1
wrapper.java.classpath.1=$jbossInstallDir/service/wrapper.jar
wrapper.java.classpath.2=$jdkInstallDir/lib/tools.jar
wrapper.java.classpath.3=$jbossInstallDir/jboss-modules.jar

# Java Library Path (location of Wrapper.DLL or libwrapper.so)
wrapper.java.library.path.1=$jbossInstallDir/service

# Java Additional Parameters
<% count=0
 jvmOptionsList.each { count++
%>wrapper.java.additional.$count=$it
<%}%>

# Java Additional Parameters End

# Initial Java Heap Size (in MB)
#wrapper.java.initmemory=768

# Maximum Java Heap Size (in MB)
#wrapper.java.maxmemory=768

# Application parameters.  Add parameters as needed starting from 1
wrapper.app.parameter.1=org.jboss.modules.Main
wrapper.app.parameter.2=-mp 
wrapper.app.parameter.3=$jbossInstallDir/modules 
wrapper.app.parameter.4=-logmodule
wrapper.app.parameter.5=\"org.jboss.logmanager\"
wrapper.app.parameter.6=-jaxpmodule
wrapper.app.parameter.7=\"javax.xml.jaxp-provider\"
wrapper.app.parameter.8=\"org.jboss.as.standalone\"
wrapper.app.parameter.9=-c
wrapper.app.parameter.10=${servername}.xml



#********************************************************************
# Wrapper Logging Properties
#********************************************************************
# Format of output for the console.  (See docs for formats)
wrapper.console.format=PM

# Log Level for console output.  (See docs for log levels)
wrapper.console.loglevel=WARN

# Log file to use for wrapper output logging.
wrapper.logfile=../logs/wrapper.log

# Format of output for the log file.  (See docs for formats)
wrapper.logfile.format=LPTM

# Log Level for log file output.  (See docs for log levels)
wrapper.logfile.loglevel=WARN

# Maximum size that the log file will be allowed to grow to before
#  the log is rolled. Size is specified in bytes.  The default value
#  of 0, disables log rolling.  May abbreviate with the 'k' (kb) or
#  'm' (mb) suffix.  For example: 10m = 10 megabytes.
wrapper.logfile.maxsize=0

# Maximum number of rolled log files which will be allowed before old
#  files are deleted.  The default value of 0 implies no limit.
wrapper.logfile.maxfiles=0

# Log Level for sys/event log output.  (See docs for log levels)
wrapper.syslog.loglevel=ERROR

#********************************************************************
# Wrapper Windows Properties
#********************************************************************
# Title to use when running as a console
wrapper.console.title="JBoss - $servername"

#********************************************************************
# Wrapper Windows NT/2000/XP Service Properties
#********************************************************************
# WARNING - Do not modify any of these properties when an application
#  using this configuration file has been installed as a service.
#  Please uninstall the service before modifying this section.  The
#  service can then be reinstalled.

# Name of the service
wrapper.ntservice.name=JBoss - $servername

# Display name of the service
wrapper.ntservice.displayname=JBoss - $servername

# Description of the service
wrapper.ntservice.description=JBoss - $servername Version: $version

# Service dependencies.  Add dependencies as needed starting from 1
$jbossServiceDependency

# Mode in which the service is installed.  AUTO_START or DEMAND_START
wrapper.ntservice.starttype=DEMAND_START

# Allow the service to interact with the desktop.
wrapper.ntservice.interactive=false

# Wait 5 minutes for jvm to shut itself down before terminating
wrapper.shutdown.timeout=300
wrapper.jvm_exit.timeout=300
'''
     def jvmOptionsList = jvmOptions.tokenize(";").collect {it as String}
     
     def engine = new groovy.text.SimpleTemplateEngine()
     def template = engine.createTemplate(wrapperScript)
     def binding = [
         servername: servername,
         version: version.getFullVersion(),
         jbossInstallDir : jbossInstallDir,
         jdkInstallDir : jdkInstallDir,
         jvmOptionsList : jvmOptionsList, 
         jbossServiceDependency : jbossServiceDependency,
         jbossBindHost : jbossBindHost
           ]
     def scriptOut = template.make(binding)
	 Ant.mkdir(jbossInstallDir+"/service/"+servername)
     def filename = jbossInstallDir+"/service/"+servername+"/wrapper.conf"
     def outFile = new File(filename)
     outFile.write(scriptOut.toString())    
}
String updateBatJvmOptions(jvmOptions, confBatStr, file){
				 // Logger.log('DEBUG', "updatePort - "+prop+" found in properties, updating "+defaultPort+" to "+port+" in "+file)
				  Map<String,String> replaceMap = new HashMap<String,String>()
				  replaceMap.put(confBatStr,jvmOptions)
				  Utils.replace (new File(file), replaceMap)
		  }
void updateLogFilePath(String file,String serverName){
 def parser = new Parser(file)
 def handlerNode = parser.findNode("//periodic-rotating-file-handler[@name='FILE']")
 def fileNode = parser.findNode("//periodic-rotating-file-handler[@name='FILE']/file[@relative-to='jboss.server.log.dir']")
 if(fileNode!=null){
  parser.removeNode(fileNode)
 }
 fileNode = parser.addNode("file", "", handlerNode)
 parser.addAttribute("relative-to", "jboss.server.log.dir", fileNode)
 parser.addAttribute("path", serverName+".log", fileNode)
 parser.output(file)
}
void updatePublicInterface(String file,String jbossBindHost){
	def parser = new Parser(file)
	def interfaceNode = parser.findNode("//interfaces/interface[@name='public']")
	def inetAddressNode = parser.findNode("//interfaces/interface[@name='public']/inet-address")
	if(inetAddressNode!=null){
		 parser.removeNode(inetAddressNode)
	}
	inetAddressNode = parser.addNode("inet-address", "", interfaceNode)
	
	String a = new String("{jboss.bind.address:"+jbossBindHost+"}")
	parser.addAttribute("value", "\$"+a, inetAddressNode)
	println inetAddressNode
	parser.output(file)
 }
void updateWebServicesHost(String file,String jbossBindHost){
	def parser = new Parser(file)
	def wsdlHostNode = parser.findNode("//wsdl-host")
	if(wsdlHostNode!=null){
		parser.removeNode(wsdlHostNode)
	}
	//parser.
	
}	
String getEncodedPassword(String userName, String password, String realm,
			String jbossInstallDir) throws Exception {
		File dir = new File(jbossInstallDir+"/bin/client");
		Vector<URL> v = new Vector<URL>();
		URL[] urls = null;
		if (dir.isDirectory()) {
			String[] names = dir.list();
			for (int i = 0; i < names.length; i++) {
				if (names[i].startsWith("jboss-client")) {
					v.add(new URL("file",null,dir.getCanonicalPath()+"/" + names[i]));
				}
			}
		} else {
			throw new Exception(jbossInstallDir + " is not a dir");
		}
		Object obj = null;
		try {
			urls = (URL[])v.toArray(new URL[0]);
			System.out.println(urls[0]);
			MCFClassLoader mcfClassLoader = new MCFClassLoader(urls);
			Class clazz = mcfClassLoader
					.loadClass("org.jboss.sasl.util.UsernamePasswordHashUtil");

			Method method = clazz.getMethod("generateHashedHexURP",
					String.class, String.class, char[].class);

			obj = method.invoke(clazz.newInstance(), userName, realm,
					password.toCharArray());
		} catch (Exception e) {
			e.printStackTrace();
		}
		String encodedPassword = (String) obj;
		return encodedPassword;

	}
def updateFile(oldText,newText,file){
				Map<String,String> replaceMap = new HashMap<String,String>()
				replaceMap.put(oldText, newText)
				Utils.replace (new File(file), replaceMap)
		       
 }
def updateJarFile(String jarFile,String destination){
	String jbossVersion = System.getenv("JBOSS_VERSION")
	System.out.println("jbossVersion is "+jbossVersion)
	String sasConfigDir = System.getenv("SCRIPT_DIR")
	System.out.println("sasConfigDir is "+sasConfigDir)
	String source = sasConfigDir+"/"+jbossVersion+"/"+jarFile
	Ant.copyFile(source,destination+"/"+jarFile, "true")
 }

def updateJstlApiModule(String jbossHome){
	String jstlModuleDir = jbossHome+"/modules/javax/servlet/jstl/api/main"
	updateJarFile("jstl.jar",jstlModuleDir)
	updateJarFile("standard.jar",jstlModuleDir)
	def parser = new Parser(jstlModuleDir+"/module.xml")
	def resourcesNode = parser.findNode('//resources')
	def resourcePathNode = parser.findNode('//resources/resource-root[@path="jboss-jstl-api_1.2_spec-1.0.2.Final.jar"]')
	if(resourcePathNode!=null){
	  parser.addComment("Comment out resourcePathNode $resourcePathNode", resourcePathNode)
	  parser.removeNode(resourcePathNode)
	}
	resourcePathNode = parser.findNode('//resources/resource-root[@path="jstl.jar"]')
	if(resourcePathNode==null){
	  resourcePathNode = parser.addNode("resource-root","",resourcesNode)
	  parser.addAttribute("path", "jstl.jar", resourcePathNode)
	}
	resourcePathNode = parser.findNode('//resources/resource-root[@path="standard.jar"]')
	if(resourcePathNode==null){
		resourcePathNode = parser.addNode("resource-root","",resourcesNode)
		parser.addAttribute("path", "standard.jar", resourcePathNode)
	}
	parser.output(jstlModuleDir+"/module.xml")
 }
}

